% This program is created by students
% from University of Sofia

?-
  G_TrX0:= 100,
  G_TrY0:= 50,
  G_TrX1:= 100,
  G_TrY1:= 250,
  G_TrX2:= 50,
  G_TrY2:= 50,

  G_Up:=0,
  G_Red_Green:=0,
  G_Show:=0,
  G_ShowDeep:=0,
  G_ShowLarge:=200,
  G_P:= -1,

  array(x, 16, 0.0),
  array(y, 16, 0.0),
  array(c, 12, 0.0),

  G_T:=8, % temp
  G_RedSlider:=0,
  G_GreenSlider:=0,
  G_BlueSlider:=0,
  G_BrightnessSlider:=48,
  ListX2=[  0, 202,   0, 200],
  ListY2=[100,  49, 140, 100],
  init(x, G_T,   ListX2), init(y, G_T,   ListY2),
  init(x, G_T+4, ListX2), init(y, G_T+4, ListY2),
  calc_color(no),

  G_T:=0,
  G_RedSlider:=33,
  G_GreenSlider:=66,
  G_BlueSlider:=100,
  G_BrightnessSlider:=50,
  G_BrightnessSlider:=50,
  ListX=[  0, 450,   0, 200],
  ListY=[100, -50, 140, 100],
  init(x, 0, ListX), init(y, 0, ListY),
  init(x, 4, ListX), init(y, 4, ListY),
  calc_color(no),

  G_WinSupport:= window( title("Digital TV"), class(support_func), pos(100, 100), size(610,860) ),
  G_WinShow:= window( title("Show"), parent(G_WinSupport), pos(700, 100), size(310,340) ),
  window( title("Tools"), parent(G_WinSupport), class(tools_func), pos(700, 520), size(310,440) ).

win_func(paint):-
  for(I, 0, 200),
    A is -1*x(G_T)+3*x(1+G_T)-3*x(2+G_T)+x(3+G_T),
    B is  3*x(G_T)-6*x(1+G_T)+3*x(2+G_T),
    C is -3*x(G_T)+3*x(1+G_T),
    D is    x(G_T)-I,
    %Discrim is 18*A*B*C*D - 4*B**3*D + B**2*C**2 - 4*A*C**3 - 27*A**2*D**2,
    Dis0 is B**2 - 3*A*C,
    Dis1 is 2*B**3 - 9*A*B*C + 27*A**2*D,
    Dis is (Dis1**2 - 4*Dis0**3),
    (Dis > 0 ->
      Temp1 is (Dis1+sqrt(Dis))/2,
      Temp2 is (Dis1-sqrt(Dis))/2,
      Temp is (abs(Temp1)>abs(Temp2)-> Temp1 else Temp2),
      Const is (Temp>0-> Temp**(1/3) else -1*(-1*Temp)**(1/3)),
      %Const is ((Dis1+sqrt(Dis2))/2)**(0.333),
      (Const=:=0.0-> write([Const, Dis0, Dis1, Dis, Temp]), nl),
      T  is (B+Const+Dis0/Const)/(-3*A),
      Y is fy(T)
    else
      R0 is sqrt((Dis1**2-Dis)/4),
      R  is R0**(1/3),
      Fi is arccos(Dis1/(2*R0))/3,
      Ta is (B+cos(Fi)       *(R+Dis0/R))/(-3*A),
      Tb is (B+cos(Fi+2*pi/3)*(R+Dis0/R))/(-3*A),
      Tc is (B+cos(Fi+4*pi/3)*(R+Dis0/R))/(-3*A),
      Ya is fy(Ta),
      Yb is fy(Tb),
      Yc is fy(Tc),
      Y1 is min(Ya, min(Yb, Yc)),
      Y3 is max(Ya, max(Yb, Yc)),
      Y2 is (Ya>Y1, Ya<Y3-> Ya else (Yb>Y1, Yb<Y3-> Yb else Yc)),
      Const is 1
    ),
    for(J, 0, G_ShowLarge),
      (Dis > 0 ->
        (T>=0, T=<1->(Y<J; G_Up=1-> Distance is J-Y else Color is rgb(255*c(G_T+3),255*c(G_T+3),0)) else Color is rgb(255,0,0))
      else
        (Y3<J; G_Up=1, Y2<J -> Distance is J-Y3 else (J>Y1, J<Y2; G_Up=1 -> Distance is J-Y1 else Color is rgb(255*c(G_T+3),255*c(G_T+3),0) ))
      ),
      (var(Color)->
        Distance2 is 255-fy2(Distance/(x(7+G_T)-x(4+G_T))),
        (G_Red_Green=0->
          Brightness := c(G_T+3)*Distance2*G_Normal/255,
          Color is rgb(Brightness*c(G_T), Brightness*c(G_T+1), Brightness*c(G_T+2))
        else
          ColorChange := Distance2/1000,
          Cr := c(G_T)-ColorChange,
          (Cr<0 -> Cr := 0),
          Cg := c(G_T+1)+ColorChange,
          (Cg<0 -> Cg := 0),
          Cb := c(G_T+2),
          Normalization:=c(G_T+3)*255/max(Cr, max(Cg, Cb)),
          Color is rgb(Normalization*Cr, Normalization*Cg, Normalization*Cb)
        )
      ), 
      %(I=150, J=200-> write([Brightness, Color]), nl),
      draw_point(I+G_TrX2, J+G_TrY2, Color),
  fail.

win_func(paint):-
  G_ShowDeep=1,
  make_deep_line.

win_func(paint):-
  G_Show=1,
  make_boarder.

win_func(paint):-
  draw_point(100+G_TrX2, 100+G_TrY2, Color),
  rgb(Color, R, G, B),
  text_out("Centre: R="+R+", G="+G+", B="+B, pos(50,10)).

win_func(close):-
  close(G_WinSupport).


tools_func(close):-
  close(G_WinSupport).

tools_func(init):-
  G_SliderR:=slider(class(slider_R), position(100-G_RedSlider), pos(20, 160), size(40, 130), vertical, both),
  G_SliderG:=slider(class(slider_G), position(100-G_GreenSlider), pos(86, 160), size(40, 130), vertical, both),
  G_SliderB:=slider(class(slider_B), position(100-G_BlueSlider), pos(152, 160), size(40, 130), vertical, both),
  G_SliderBr:=slider(class(slider_Br), position(100-G_BrightnessSlider), pos(220, 160), size(40, 130), vertical, both),
  check_box(text("Continue Up"), class(check_up), pos(10,10), size(130, 20)),
  check_box(text("Red Green"), class(red_green), pos(140,10), size(140, 20)),
  check_box(text("Show Boarder"), class(show_boarder), pos(10,30), size(130, 20)),
  check_box(text("Show Compresion"), class(show_compresion), pos(140,30), size(140, 20)),
  check_box(text("Show Deep"), class(show_deep), pos(10,50), size(130, 20)),
  check_box(text("Show Large"), class(show_large), pos(10,70), size(130, 20)).

tools_func(paint):-
  pen(1,0),
  text_out("Red is "+round(100*c(G_T))+"%  ", pos(10, 300)),
  text_out("Green is "+round(100*c(G_T+1))+"%  ", pos(10, 320)),
  text_out("Blue is "+round(100*c(G_T+2))+"%  ", pos(10, 340)),
  text_out("Brightness is "+c(G_T+3)+"             ", pos(10, 360)),
  brush(rgb(255,0,0)),
  ellipse(30, 140, 50, 160),
  brush(rgb(0,255,0)),
  ellipse(96, 140, 116, 160),
  brush(rgb(0,0,255)),
  ellipse(162, 140, 182, 160),
  brush(rgb(255,255,255)),
  ellipse(230, 140, 250, 160),
  brush(rgb(G_Normal*c(G_T)*c(G_T+3), G_Normal*c(G_T+1)*c(G_T+3), G_Normal*c(G_T+2)*c(G_T+3))),
  rect(200, 340, 240, 380),
  brush(rgb(G_Normal*c(G_T), G_Normal*c(G_T+1), G_Normal*c(G_T+2))),
  rect(240, 340, 280, 380).

slider_R( scroll(Type, Val, NewPos) ):-
  G_RedSlider:=100-NewPos,
  calc_color(Type).
slider_G( scroll(Type, Val, NewPos) ):-
  G_GreenSlider:=100-NewPos,
  calc_color(Type).
slider_B( scroll(Type, Val, NewPos) ):-
  G_BlueSlider:=100-NewPos,
  calc_color(Type).
slider_Br( scroll(Type, Val, NewPos) ):-
  G_BrightnessSlider:=100-NewPos,
  calc_color(Type).

calc_color(Type):-
  (G_RedSlider+G_GreenSlider+G_BlueSlider=:=0->
    c(G_T):=1/3,
    c(G_T+1):=1/3,
    c(G_T+2):=1/3
  else
    c(G_T):=G_RedSlider/(G_RedSlider+G_GreenSlider+G_BlueSlider),
    c(G_T+1):=G_GreenSlider/(G_RedSlider+G_GreenSlider+G_BlueSlider),
    c(G_T+2):=G_BlueSlider/(G_RedSlider+G_GreenSlider+G_BlueSlider)
  ),
  G_Normal:=255/max(c(G_T), max(c(G_T+1), c(G_T+2))),
  c(G_T+3):=exp((G_BrightnessSlider-50)/20),
  (tools_func(paint); true),
  (Type=line; Type=page; Type=thumb_moved_to->
    update_window(G_WinShow)
  ).

make_deep_line:-
  pen(3, rgb(0,0,255)),
  line(40, G_TrY2+100, 40, x(7+G_T)-x(4+G_T)+G_TrY2+100),
  fail.

make_boarder:-
  for(T0, 0, 1000),
    T is T0/1000, T1 is 1-T,
    X is T1**3*x(G_T)+3*T1**2*T*x(1+G_T)+3*T1*T**2*x(2+G_T)+T**3*x(3+G_T),
    Y is T1**3*y(G_T)+3*T1**2*T*y(1+G_T)+3*T1*T**2*y(2+G_T)+T**3*y(3+G_T),
      draw_point(X+G_TrX2, Y+G_TrY2, rgb(255,0,0)),
  fail.

check_up(press):-
  set_check_box_value(_,1-get_check_box_value(_)),
  G_Up:=1-G_Up,
  update_window(G_WinSupport),
  update_window(G_WinShow).
red_green(press):-
  set_check_box_value(_,1-get_check_box_value(_)),
  G_Red_Green:=1-G_Red_Green,
  update_window(G_WinShow).
show_boarder(press):-
  set_check_box_value(_,1-get_check_box_value(_)),
  G_Show:=1-G_Show,
  (G_Show=1->
    set_active_window(G_WinShow),
    make_boarder
  else
    update_window(G_WinShow)
  ).
show_compresion(press):-
  set_check_box_value(_,1-get_check_box_value(_)),
  G_T:=8-G_T,
  G_RedSlider:=100*c(G_T),
  G_GreenSlider:=100*c(G_T+1),
  G_BlueSlider:=100*c(G_T+2),
  G_BrightnessSlider:=50+20*log(c(G_T+3)),
  set_slider_pos(G_SliderR, 100-G_RedSlider),
  set_slider_pos(G_SliderG, 100-G_GreenSlider),
  set_slider_pos(G_SliderB, 100-G_BlueSlider),
  set_slider_pos(G_SliderBr, 100-G_BrightnessSlider),
  calc_color(line),
  update_window(G_WinSupport).
show_deep(press):-
  set_check_box_value(_,1-get_check_box_value(_)),
  G_ShowDeep:=1-G_ShowDeep,
  (G_ShowDeep=1->
    set_active_window(G_WinShow),
    make_deep_line
  else
    update_window(G_WinShow)
  ).
show_large(press):-
  set_check_box_value(_,1-get_check_box_value(_)),
  G_ShowLarge:=500-G_ShowLarge,
  set_size(G_WinShow, 300, 120+G_ShowLarge),
  update_window(G_WinShow).

support_func(paint):-
  brush(rgb(255,255,255)),
  pen(1, rgb(0,0,0)),
  line(0,G_TrY1, 600, G_TrY1),
  line(0,256+G_TrY1, 600, 256+G_TrY1),
  line(0,512+G_TrY1, 600, 512+G_TrY1),
  text_out(-1*y(4+G_T)+3*y(5+G_T)-3*y(6+G_T)+y(7+G_T), pos(20, 530+G_TrY1)),
  pen(3, rgb(255,0,0)),
  bezier_line(x(G_T)+G_TrX0, y(G_T)+G_TrY0, x(1+G_T)+G_TrX0, y(1+G_T)+G_TrY0, x(2+G_T)+G_TrX0, y(2+G_T)+G_TrY0, x(3+G_T)+G_TrX0, y(3+G_T)+G_TrY0),
  for(P, 0, 3),
    ellipse(x(P+G_T)+G_TrX0-10, y(P+G_T)+G_TrY0-10, x(P+G_T)+G_TrX0+10, y(P+G_T)+G_TrY0+10),
  fail.
support_func(paint):-
  pen(3, rgb(0,127,0)),
  line(x(4+G_T)+G_TrX1,G_TrY1+540, x(7+G_T)+G_TrX1, G_TrY1+540),
  bezier_line(x(4+G_T)+G_TrX1, y(4+G_T)+G_TrY1, x(5+G_T)+G_TrX1, y(5+G_T)+G_TrY1, x(6+G_T)+G_TrX1, y(6+G_T)+G_TrY1, x(7+G_T)+G_TrX1, y(7+G_T)+G_TrY1),
  for(P, 4, 7),
    ellipse(x(P+G_T)+G_TrX1-10, y(P+G_T)+G_TrY1-10, x(P+G_T)+G_TrX1+10, y(P+G_T)+G_TrY1+10),
  fail.
support_func(paint):-
  for(T0, 1000, 2000),
    T is T0/1000, T1 is 1-T,
    X is T1**3*x(4+G_T)+3*T1**2*T*x(5+G_T)+3*T1*T**2*x(6+G_T)+T**3*x(7+G_T),
    Y is T1**3*y(4+G_T)+3*T1**2*T*y(5+G_T)+3*T1*T**2*y(6+G_T)+T**3*y(7+G_T),
      draw_point(X+G_TrX1, Y+G_TrY1, rgb(0,0,255)),
  fail.
support_func(paint):-
  G_Up=1,
  for(T0, -1000, 0),
    T is T0/1000, T1 is 1-T,
    X is T1**3*x(4+G_T)+3*T1**2*T*x(5+G_T)+3*T1*T**2*x(6+G_T)+T**3*x(7+G_T),
    Y is T1**3*y(4+G_T)+3*T1**2*T*y(5+G_T)+3*T1*T**2*y(6+G_T)+T**3*y(7+G_T),
      draw_point(X+G_TrX1, Y+G_TrY1, rgb(255,0,0)),
  fail.
support_func(paint):-
  Start is (G_Up=1-> -200 else 0),
  for(T0, Start, 800),
    T is T0/400, T1 is 1-T,
    Y is T1**3*y(4+G_T)+3*T1**2*T*y(5+G_T)+3*T1*T**2*y(6+G_T)+T**3*y(7+G_T),
      draw_point(T0+G_TrX1, Y+G_TrY1+256, (T0<0; T0>400-> rgb(255,0,0) else rgb(0,0,255))),
  fail.

support_func(mouse_click(X, Y)):- 
  for(P, 0, 3),
    (x(P+G_T)+G_TrX0-X)**2+(y(P+G_T)+G_TrY0-Y)**2<100,
  G_P:=P.
support_func(mouse_click(X, Y)):- 
  for(P, 4, 7),
    (x(P+G_T)+G_TrX1-X)**2+(y(P+G_T)+G_TrY1-Y)**2<100,
  G_P:=P.

support_func(mouse_click_up(X, Y)):-
  G_P> -1,
  update_window(G_WinShow),
  G_P:= -1.

support_func(mouse_move(X, Y)):- 
  G_P> -1,
  (G_P>3-> TrX is G_TrX1, TrY is G_TrY1 else TrX is G_TrX0, TrY is G_TrY0),
  y(G_P+G_T):=Y-TrY,
  (not(G_P=0; G_P=3)->
    x(G_P+G_T):=X-TrX
  ),
  update_window(_).


Y is fy(T):-
  T1 is 1-T,
  Y := T1**3*y(  G_T) + 3*T1**2*T*y(1+G_T) + 3*T1*T**2*y(2+G_T) + T**3*y(3+G_T).

Y is fy2(T):-
  T1 is 1-T,
  Y := T1**3*y(4+G_T) + 3*T1**2*T*y(5+G_T) + 3*T1*T**2*y(6+G_T) + T**3*y(7+G_T).

init(Array, From, [H|T]):-
  Array(From):=H,
  From2 is From+1,
  init(Array, From2, T).
init(_, _, []).

