init_map:-
  G_Wagons_in_use := 240,
  G_time_period_fast := 180,
  G_Statistic_averSpeed := 50/0.36.

R is end_map :- R:= 3100000.

Where is finish_station(Posoka):-
  Where := (Posoka=:= -1 -> 1 else 30).

station(no, 35, _, _, "Business", "Park").
station(no, 34, _, _, "Balan", "").
station(no, 33, _, _, "Alexander", "Malinov").

station(no, 32, _, _, "Sofia", "Airport").
station(no, 31, _, _, "Sofiyska", "Sveta Gora").
station(yes, 30,3600000, _, "Iskarsko", "Shose").
station(yes, 29,3462000, _, "Druzhba", "").
station(yes, 28,3338000, _, "Tsarigradsko", "Shose").
station(yes, 27,3214000, _, "Mladost 3", "").
 
station(yes, 26,3090000, _, "Mladost 1", "").
station(yes, 25,2966000, _, "Musagenitsa", "").
station(yes, 24,2842000, _, "G.M.", "Dimitrov").
station(yes, 23,2718000, _, "Joliot", "Curie").
station(yes, 22,2594000, _, "Vasil Levski", "Stadium").
station(yes, 21,2470000, _, "Kliment", "Ohridski").

station(yes, 20,2346000, 120, "Serdika", "").
station(yes, 19,2222000, 100, "Opalchenska", "").
station(yes, 18,2098000,  80, "Konstantin", "Velichkov").
station(yes, 17,1974000,  60, "Vardar", "").
station(yes, 16,1850000,  40, "Zapaden", "Park").
station(yes, 15,1736000,  20, "Lyulin", "").
station(yes, 14,1612000,   0, "Slivnitsa", "").

station(yes, 13,1488000, _, "Obelya", "").
station(yes, 12,1364000, _, "Lomsko", "Shose").
station(yes, 11,1240000, _, "Beli", "Dunav").
station(yes, 10,1116000, _, "Nadezhda", "").
station(yes, 9,  992000, _, "Han", "Kubrat").
station(yes, 8,  868000, _, "Knyaginya", "Maria Luiza").
station(yes, 7,  744000, _, "Central", "Rail Station").
station(yes, 6,  620000, _, "Lavov", "Most").
station(yes, 5,  496000, _, "Serdika 2", "").
station(yes, 4,  372000, _, "Palace", "of Culture").
station(yes, 3,  248000, _, "European", "Union").
station(yes, 2,  124000, _, "James", "Baucher").
station(yes, 1,       0, _, "Vitosha", "").

local_metro_line(-5000, 1520, 5000, 1520, no, no).
local_metro_line(-5000, 1010, 5000, 1010, no, no).

metro_line(-18000, 1010, -8000, 1010, no, no). % +10 for beauty
metro_line(3608000, 1520,3618000, 1520, no, no). % +20 for beauty

metro_line(-8000, 1010,  -5000, 1010,  12, no).
metro_line(3605000, 1520, 3608000, 1520, no,  4).

metro_arc( -8000, 1000,  1, -6500, 1250, 4625, 12).
metro_arc( -5000, 1500,  1, -6500, 1250, 4625, no).

metro_arc(3605000, 1000,  1,  3606500, 1250, 4625, no).
metro_arc(3608000, 1500,  1,  3606500, 1250, 4625, 4).

